.MODEL TINY
.386P


.DATA

nadpis          db 'Detekcia Soft-Ice zmenou obsluhy Int 41h',0dh, 0ah,24h
nasiel          db 'Soft-Ice aktivny',24h
nenasiel        db 'Soft-Ice nenasiel',24h

.CODE
.STARTUP

                lea  dx, nadpis
                mov  ah,9                       ;cislo funkcie->Zobraz retazec
                int  21h                        ;volanie INT 21h
                                                ;zobrazi nadpis


                xor  ax,ax                      ;vynuluje ax
                mov  es,ax                      ;do es da 0 (nastavi segment vektorov preruseni)
                mov  bx,cs                      ;do bx ulozi segment programu
                lea  dx, nova_int41              ;do dx da offsetovu cast adresy novej obsluhy int 41h
                xchg dx, es:[41h*4]             ;nastavi offsetovu cast adresy novej obluhy int 41h a zaroven offsetovu
                                                ;cast adresy starej obsluhy da do dx
                xchg bx, es:[41h*4+2]           ;nastavi segmentovu cast adresy novej obsluhy int 41h a zaroven segmentovu
                                                ;cast adresy starej obsluhy da do bx
                in   al, 40h                    ;nacita hodnotu do al

                xor  cx,cx                      ;nuluje cx
                int  41h                        ;vola int 41h. V pripade, ak nie je Soft-Ice aktivny
                                                ;v pamati, vykona novu obsluhu

                xchg dx, es:[41h*4]             ;nastavi offsetovu cast adresy povodnej obsluhy int 41h

                xchg bx, es:[41h*4+2]           ;nastavi segmentovu cast adresy povodnej obsluhy int 41h

                cmp  cl,al                      ;porovna cl a al, ak nie je Soft-Ice aktivny v pamati, budu sa zhodovat
                jnz  short skok                 ;skok ak je Soft-Ice aktivny v pamati

                lea  dx, nenasiel
                jmp  short dalej

skok:
                lea    dx, nasiel

dalej:
                mov    ah,9                     ;cislo funkcie->Zobraz retazec
                int    21h                      ;volanie INT 21h

                mov    ax,4c00h                 ;cislo funkcie->Ukonci program
                int    21h                      ;volanie INT 21h

nova_int41 PROC                                 ;toto je nasa nova obsluha INT 41h

                mov cl,al                       ;z al presunie hodnotu do cl na znak, ze Soft-Ice nie je aktivny v pamati

                iret                            ;spat z obsluhy

nova_int41 ENDP

END